﻿package {
	
	import flash.display.*;
	import flash.display.BitmapData;
	import flash.geom.Rectangle;
	import flash.events.*;
	import flash.filters.*;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.filters.BitmapFilter;
    import flash.filters.BitmapFilterQuality;
    import flash.filters.BlurFilter;
	import flash.filters.DropShadowFilter;
	import BitmapGrabber;
	import caurina.transitions.Tweener;
	import caurina.transitions.properties.FilterShortcuts;
	import caurina.transitions.properties.CurveModifiers;

	
	public class BitmapSnapShot_v2 extends MovieClip{
		
		/*
		**@Author             Gerry Creighton - www.thespikeranch.com - 9-2008 -  gerry@thespikeranch.com
		**@Param    total     This is the total number of snap shots to display. This gets calculated by cols X rows 
		**                    which are calculated by the snapSize.
		**@Param    count     This is a copy of the uint total but is used to count down for the animations. This must be
		**                    set after the total is set so do not move.
		**@Param    startx    This is the x position to place everything on the stage.
		**@Param    starty    This is the y position to place everything on the stage.
		**@Param    posx      This is the x position of the snap shots.
		**@Param    posy      This is the y position of the snap shots.
		**@Param    boxSize   This is the size of the main box that gets cut up. I used 400 since that was easily divisible.
		**@Param    snapSize  This is the size of the cube that animates. Right now the size has to be a number that 400 can easily be dived by. 
		**                    I used the Tweener animation classes for the animations, you can reference the documentation for those classes
		**                    at the following location: http://tweener.google.com
		*/
		private var Box:MovieClip;
		private var tf:TextField;
		private var fmt:TextFormat;
		private var play_btn:PlayAgain_btn;
		
		private var snapSize:Number = 40;
		private var boxSize:Number = 400;
		//
		private var pictures:Array = new Array();
		private var total:uint;
		private var count:uint = total;
		private var cols:Number;
		private var rows:Number;
		private var bw:Number;
		private var bh:Number;
		private var startx:Number = 40;
		private var starty:Number = 40;
		private var posx:Number;
		private var posy:Number;
		private var dsfilter:DropShadowFilter;
		private var imgCount:Number = 0;
		
		
		public function BitmapSnapShot_v2(){
			//initialize filters to be used in Animate()
			FilterShortcuts.init();
			CurveModifiers.init();
			//
			dsfilter = new DropShadowFilter(2,45,0x000000,.2,4,4,1,3,false,false,false);
		
			//add replay btn
			play_btn = new PlayAgain_btn();
			play_btn.x = stage.stageWidth * 0.5 - play_btn.width * 0.5;
			play_btn.y = 0 - (play_btn.height+40);
			play_btn.buttonMode = true;
			play_btn.useHandCursor = true;
			play_btn.filters = [dsfilter];
			addChild(play_btn);
			
			//make the box and text field to chop up
			makeBox();
		}
		
		private function makeBox():void{
			//create a box mc and add a textField to it
			//text
			fmt = new TextFormat();
			fmt.color = 0xFFFFFF;
			fmt.size = 14;
			fmt.font = "Helvetica";
			//
			tf = new TextField();
			tf.multiline = true;
			tf.wordWrap = true;
			tf.width = boxSize;
			tf.height = boxSize;
			tf.x = 2;
			tf.y = 2;
			//add greek text to fill most of the box
			tf.text = "Et vero, typicus decet praemitto, gemino suscipit saepius nutus oppeto. Abbas pertineo praesent ex feugiat capio blandit pecus acsi vel, letatio quidne qui. Accumsan validus sagaciter nulla secundum delenit. Os facilisis ne eu esse aliquip incassum defui defui causa iustum. Autem distineo minim ex paulatim consequat ludus importunus aliquam distineo duis duis fere pertineo multo. Ulciscor qui pertineo ad inhibeo nisl, refoveo sed lucidus letatio similis gilvus, abbas dignissim. Iustum et vicis hendrerit premo esse. Feugait feugait bene haero iusto te nibh vulputate ad at epulae, consequat.\n\n\n\n Et vero, typicus decet praemitto, gemino suscipit saepius nutus oppeto. Abbas pertineo praesent ex feugiat capio blandit pecus acsi vel, letatio quidne qui. Accumsan validus sagaciter nulla secundum delenit. Os facilisis ne eu esse aliquip incassum defui defui causa iustum. Autem distineo minim ex paulatim consequat ludus importunus aliquam distineo duis duis fere pertineo multo. Ulciscor qui pertineo ad inhibeo nisl, refoveo sed lucidus letatio similis gilvus, abbas dignissim. Iustum et vicis hendrerit premo esse. Feugait feugait bene haero iusto te nibh vulputate ad at epulae, consequat. ";
			//set formate after text has been set
			tf.setTextFormat(fmt);
			//box
			Box = new MovieClip();
			Box.graphics.beginFill(0x666666);
			//Box.graphics.drawRect(0,0,400,400);
			Box.graphics.drawRoundRect(0,0,boxSize,boxSize,4);
			Box.graphics.endFill();
			Box.x = startx;
			Box.y = starty;
			Box.filters = [dsfilter];
			addChild(Box);
			Box.addChild(tf);
			Box.alpha = 0;
			bw = Box.width;
			bh = Box.height;
			setDimensions(Box);
			Tweener.addTween(Box,{alpha:1,time:2,transition:"easeoutexpo",onComplete:buildSnaps,onCompleteParams:[Box]});
		}


		private function setDimensions(img:MovieClip):void{
			
			cols = Math.round(bw/snapSize);
			rows = Math.round(bh/snapSize);
			total = cols * rows;
			count = total;
			
		}
		public function buildSnaps(mySource:MovieClip):void{
			//loop to make snapshots of image and position them
			for(var i:uint = 0; i<total; i++){
				//loop to set x and y positions of squares
				posx = startx + (i % cols) * snapSize;
				posy = starty + (Math.floor(i / rows) * snapSize);
				//take snapshots of different parts of the mySource image
				var bmpData:BitmapData = BitmapGrabber.grab(mySource,new Rectangle(posx-40,posy-40,snapSize,snapSize), true );
				//add BitmapData to an mc
				var holder:MovieClip = new MovieClip();
				addChild(holder);
				var newClip:Bitmap = new Bitmap(bmpData);
				holder.addChild(newClip);
				holder.x = posx;
				holder.y = posy;
				//
				pictures.push(holder);
		    }
			//remove original image to save memory
			removeChild(mySource);
			//animate snaps 
			Animate();
		}
		
		private function getBitmapFilter():BitmapFilter {
			//blur filter to blur the boxes during animation
            var blurX:Number = 30;
            var blurY:Number = 30;
            return new BlurFilter(blurX, blurY, BitmapFilterQuality.HIGH);
        }

		private function ranDom(min:Number, max:Number):Number {
			//generates a random number between min and max
			var randomNum:Number = Math.floor(Math.random() * (max - min )) + min;
			return randomNum;
		}
		//
		public function Animate():void {
			//trace("pictures length: "+pictures.length);
			if (count >= 0) {
				for(var i:uint = 0; i< pictures.length+1; i++){
					//add event listener to stop and clear animations
					pictures[0].addEventListener(Event.ENTER_FRAME,checkLoc);
					var clip = pictures[count];
					var rot:Number = ranDom(-250, 250);
					//tween out eith a delay between clips
					var cx:Number = ranDom(-400,stage.stageWidth+200);
					var cy:Number = ranDom(-200,stage.stageHeight+400);
					//animations
					Tweener.addTween(clip,{rotation:rot,time:5,delay: 0.012 * i,transition:"linear"});
					Tweener.addTween(clip,{ x:stage.stageWidth+40,y:stage.stageHeight/2,_bezier:{x:startx+100, y:stage.stageHeight+100},time:1.5,delay: 0.015 * i,transition:"easeInOutBack", transitionParams:{overshoot:0.3}});
					Tweener.addTween(clip,{alpha:0,time:1,delay: 0.015 * i,transition:"easeInQuart"});
					Tweener.addTween(clip,{_Blur_blurX:20,_Blur_blurY:20,time:.3,delay: 0.015 * i,transition:"linear"});
					//
					count--;
				}
				
			}
			
		}
        private function checkLoc(e:Event):void{
			//works to check location of last box animating to see 
			//if it's off stage-right.
			if(pictures[0].x >= stage.stageWidth+20){
				 pictures[0].removeEventListener(Event.ENTER_FRAME,checkLoc); 
				      AllDone();
					
		    }
		}
		private function AllDone():void{
			//reset everything and take fla to 2nd frame
			//trace("AllDone");
			count = 0;
			total = 0;
			rows = 0;
			cols = 0;
			pictures = [];
			//slide replay btn down
			Tweener.addTween(play_btn,{alpha:1,y:237,time:.5,transition:"easeoutexpo"});
 			play_btn.addEventListener(MouseEvent.CLICK,replay);

		}
		//
		private function replay(e:MouseEvent):void{
			//ldr.unload();
			FilterShortcuts.init();
			CurveModifiers.init();
			Tweener.addTween(play_btn,{alpha:1,y:0-40,time:.5,transition:"easeInOutBack", transitionParams:{overshoot:2.5},onComplete:makeBox});
		}
		//
	}
	//

}
//
